<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
 * StructType
 * @package Dg
 * @subpackage Structs
 */
class DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo extends DgFormattedTextType
{
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Type;
    /**
     * Constructor method for VehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     * @uses DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo::setType()
     * @param string $type
     */
    public function __construct($type = null)
    {
        $this
            ->setType($type);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \dgsoft\EnumType\DgLocationDetailShuttleInfoType::valueIsValid()
     * @uses \dgsoft\EnumType\DgLocationDetailShuttleInfoType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\dgsoft\EnumType\DgLocationDetailShuttleInfoType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $type, implode(', ', \dgsoft\EnumType\DgLocationDetailShuttleInfoType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgVehicleLocationAdditionalDetailsTypeShuttleShuttleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
